//=============================================================================
// Filename: SCRDRV_MAIN.C
//=============================================================================
// Author:      Paul E. Schoen
// Company:     P S Technology Inc.
// Revision:    0.10
// Checksum:    
// Date:        01/08/17
//=============================================================================
// Compiled using MPLAB-XC8-v1.33
// Include Files: P18F2420.H
//=============================================================================
//----------------------------------------------------------------------------
#include <xc.h>
#include "SCRDRV.h"
#include "mcc_generated_files/mcc.h"
//#include "mcc_generated_files/adc.h"
//#include "mcc_generated_files/cog1.h"
//#include "mcc_generated_files/eusart.h"
//#include "mcc_generated_files/interrupt_manager.h"
//#include "mcc_generated_files/pwm3.h"
//#include "mcc_generated_files/tmr0.h"
//#include "mcc_generated_files/tmr2.h"
//#include <pic16f1778.h>
//#include <usart.h>
#include <string.h>
//#include <stdlib.h> // for atoi
#include <stdio.h>
//#include <sources\common\atoi.c>
//----------------------------------------------------------------------------
// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

//#define DEBUG
#define COMM
#define MCC

#ifdef _18F2420
// CONFIG1H
#pragma config OSC = HS      // Oscillator Selection bits (External RC oscillator, port function on RA6)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal/External Oscillator Switchover bit (Oscillator Switchover mode disabled)

// CONFIG2L
#pragma config PWRT = ON       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOREN = SBORDIS  // Brown-out Reset Enable bits (Brown-out Reset enabled in hardware only (SBOREN is disabled))
#pragma config BORV = 3         // Brown Out Reset Voltage bits (Minimum setting)

// CONFIG2H
#pragma config WDT = ON         // Watchdog Timer Enable bit (WDT enabled)
#pragma config WDTPS = 32768    // Watchdog Timer Postscale Select bits (1:32768)

// CONFIG3H
#pragma config CCP2MX = PORTC   // CCP2 MUX bit (CCP2 input/output is multiplexed with RC1)
#pragma config PBADEN = OFF      // PORTB A/D Enable bit (PORTB<4:0> pins are configured as analog input channels on Reset)
#pragma config LPT1OSC = OFF    // Low-Power Timer1 Oscillator Enable bit (Timer1 configured for higher power operation)
#pragma config MCLRE = OFF       // MCLR Pin Enable bit (MCLR pin enabled; RE3 input pin disabled)

// CONFIG4L
#pragma config STVREN = ON      // Stack Full/Underflow Reset Enable bit (Stack full/underflow will cause Reset)
#pragma config LVP = OFF         // Single-Supply ICSP Enable bit (Single-Supply ICSP disabled)
#pragma config XINST = OFF      // Extended Instruction Set Enable bit (Instruction set extension and Indexed Addressing mode disabled (Legacy mode))

// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (000800-001FFFh) not code-protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (002000-003FFFh) not code-protected)

// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot block (000000-0007FFh) not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM not code-protected)

// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000800-001FFFh) not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (002000-003FFFh) not write-protected)

// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot block (000000-0007FFh) not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write-protected)

// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000800-001FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (002000-003FFFh) not protected from table reads executed in other blocks)

// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot block (000000-0007FFh)not protected from table reads executed in other blocks)

#elif defined(_18F242)
// CONFIG1H
#pragma config OSC = HS      // Oscillator Selection bits (External RC oscillator, port function on RA6)
#pragma config OSCS = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)

// CONFIG2L
#pragma config PWRT = ON       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOR = ON  // Brown-out Reset Enable bits (Brown-out Reset enabled in hardware only (SBOREN is disabled))
#pragma config BORV = 27         // Brown Out Reset Voltage bits (Minimum setting)

// CONFIG2H
#pragma config WDT = ON         // Watchdog Timer Enable bit (WDT enabled)
#pragma config WDTPS = 128    // Watchdog Timer Postscale Select bits (1:32768)

// CONFIG3H
#pragma config CCP2MUX = ON   // CCP2 MUX bit (CCP2 input/output is multiplexed with RC1)

// CONFIG4L
#pragma config STVR = ON      // Stack Full/Underflow Reset Enable bit (Stack full/underflow will cause Reset)
#pragma config LVP = OFF         // Single-Supply ICSP Enable bit (Single-Supply ICSP disabled)

// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (000800-001FFFh) not code-protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (002000-003FFFh) not code-protected)

// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot block (000000-0007FFh) not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM not code-protected)

// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000800-001FFFh) not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (002000-003FFFh) not write-protected)

// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot block (000000-0007FFh) not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write-protected)

// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000800-001FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (002000-003FFFh) not protected from table reads executed in other blocks)

// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot block (000000-0007FFh)not protected from table reads executed in other blocks)

#elif defined(_16F1778)
#ifndef MCC
// CONFIG1
#pragma config FOSC = ECH       // Oscillator Selection Bits (ECH, External Clock, High Power Mode (4-20 MHz): device clock supplied to CLKIN pins)
#pragma config WDTE = ON        // Watchdog Timer Enable (WDT enabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = OFF      // MCLR Pin Function Select (MCLR/VPP pin function is digital input)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = OFF   // Clock Out Enable (CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin)
#pragma config IESO = ON        // Internal/External Switchover Mode (Internal/External Switchover Mode is enabled)
#pragma config FCMEN = ON       // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is enabled)

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config PPS1WAY = ON     // Peripheral Pin Select one-way control (The PPSLOCK bit cannot be cleared once it is set by software)
#pragma config ZCD = OFF        // Zero-cross detect disable (Zero-cross detect circuit is disabled at POR)
#pragma config PLLEN = OFF      // Phase Lock Loop enable (4x PLL is enabled when software sets the SPLLEN bit)
#pragma config STVREN = ON      // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LPBOR = OFF      // Low-Power Brown Out Reset (Low-Power BOR is disabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)
#endif
#endif

const char PROJECT[] @ 0x100 = "SCRDRV";
//__attribute__((address(0x100)))    const char PROJECT[] = "SCRPCB1";
__attribute__((address(0x110)))    const char VERSION[] = "0.10";
__attribute__((address(0x120)))    const char DATE[] = "01/08/17";



//#define DEBUG       1
            

//----------------------------------------------------------------------------
// Main routine

void    putsUSART( char* s ) {
    for( int i = 0; i < strlen(s); i++ )
        EUSART_Write(s[i]);
}
void    main ()
{
#ifdef MCC
    SYSTEM_Initialize();
#else
    LATA = 0xff;                // INIT (RA4) OFF, ERRORLED (RA5) ON
    TRISA = 0b11001011;         // RA<2,4-5> output
    LATB = 0b11110011;          // SCR1 and SCR2 low = Off
    TRISB = 0b11110011;         // SCR1, SCR2 outputs
    LATC = 0b00000000;
    TRISC = 0b10111001;         // TX Digital Out, RX Digital In, RC1:2 out
    
    INTCONbits.GIE = 0;         // disable global interrupts
 /*   INTCONbits.RBIE = 0;        // disable interrupt on change (RBIE=IOCIE)
    INTCONbits.RBIF = 0;        // clear flag if set (RBIF=IOCIF)
    INTCONbits.INT0IE = 1;      // enable external INT0
    INTCONbits.INT0IF = 0;      // clear flag if set (RBIF=IOCIF)
    
    INTCON3bits.INT1E = 0;      // disable INT1
    INTCON3bits.INT2E = 0;      // disable INT2
    INTCON3bits.INT1F = 0;      // Clear INT1 flag if it got set
    INTCON3bits.INT2F = 0;      // Clear INT2 flag if it got set
 */   
    INTCONbits.GIE = 1;          //enable interrupts (GIE = GIEH))
#endif
    asm("CLRWDT");
    strcpy((char*)Command, (char*)"");
    SetupTimer0();
    SetupADC();
    SetupUSART();
    SetupPWM();
//    SetPWM(PWM_VAL);
    INITON = FALSE;
    rxChar = 0;
    INTCONbits.GIE = 1;          //enable interrupts (GIE = GIEH))
    DelayMsec(100);
#ifdef  DEBUG
    maxOnCycles = 3;
#else
    maxOnCycles = 0;
#endif
  while (1)
    {
      DelayMsec(100);
      ARMED = FALSE;    //SCRstat.Bit.
      STARTED = FALSE;  //SCRmode.Bit.
      RUNNING = FALSE;  //SCRmode.Bit.
      // Wait for conditions to enter ARMED state
      while( !ARMED) {
                       //slow toggle LED on RB0
        EXTREF = FALSE;                 //SCRstat.Bit.
        DelayMsec(100);                 // allow time to detect EXTREF
        STATLED = STATOK;
        asm("CLRWDT");
#ifdef  DEBUG
        ARMED = TRUE;
        break;
#endif
        if( SCR1GOFF && SCR2GOFF && EXTREF ) {
            ARMED = TRUE;
            break; }
        else {
          STATLED = STATERR;
          putsUSART((char*)" Error\r\n");
          DelayMsec(1000); } 
        }
      putsUSART((char*)" Armed\r\n");
      // ARMED and waiting for INIT
#ifdef  DEBUG
      while (PORTBbits.RB1) {
#else
      while( PORTBbits.RB1 && SCR1GOFF && SCR2GOFF && EXTREF) { //wait for INIT
#endif
          if( !SerialSet )
            Phase = ADCval/8; // 1024/8 = 128
        EXTREF = FALSE;
        STATLED = STATOK;
        DelayMsec(100);
        if( rxChar == '?' )
            id();
        if( rxChar == 'I') {
            break; }
        if( rxChar != 0 ) {
            readCommand();
            rxChar = 0; }
        asm("CLRWDT");
        }
      // Initiated - set flags for phase delay
#ifdef  DEBUG
      if( EXTREF ) {
#else
      if(SCR1GOFF && SCR2GOFF && EXTREF) { // Initiated
#endif
        ARMED = FALSE;
        INITON = TRUE;  //SCRmode.Bit.
        // Continue while INIT is asserted
        while( (!PORTBbits.RB1 || (rxChar=='I') ) && !RUNNING ) {
          asm("CLRWDT");
          STATLED = STATERR; }
        INITON = FALSE;
        putsUSART((char*)" Initiated\r\n");
        while( (!PORTBbits.RB1 || (rxChar=='I') ) && RUNNING ) {
          STATLED = STATOK;
          asm("CLRWDT");
        }
      }
    INITON = FALSE;
    SCR1 = 0;
    SCR2 = 0;
    OUTDRV = OUTOFF;
    STARTED = FALSE;
    RUNNING = FALSE;
    putsUSART((char*)" Stopped\r\n");
    rxChar = 0;
    while( !PORTBbits.RB1 )
        asm("CLRWDT"); //wait fir INIT release
  }
}

//----------------------------------------------------------------------------
// High priority interrupt vector

//void interrupt high_priority inthigh(void)
//{
//    InterruptHandlerHigh();
//}

/*
//----------------------------------------------------------------------------
// Low priority interrupt vector

void interrupt low_priority intlow(void)
{
    InterruptHandlerLow();
}
*/

//----------------------------------------------------------------------------
// Interrupt routines
#ifndef MCC
void interrupt InterruptHandler()
{
  if (INTCONbits.TMR0IF)                // 1843200/256 = 7200/sec
    { //check for TMR0 overflow
      if( timer0>0)
          timer0--;                     // for DelayMsec
      if( STARTED ) {
          if(StartCount > 0)
            StartCount--;
          else {
            SCR1 = 1;
            SCR2 = 1;
            OUTPUT=OUTON;
            STARTED = FALSE;
            RUNNING = TRUE;
            if( maxOnCycles > 0)
                OnCycles = maxOnCycles;
            }
        }
      if( ADCcount > 0 )
          ADCcount--;
      else {
          ADCcount = 100;               // 7200/100 = 72/sec
          ADCON0bits.GO = 1;          // Start next conversion
          }
      INTCONbits.TMR0IF = 0;            //clear interrupt flag
    }
  else if ( INTCONbits.INTF ) {       // external INT0 on RB0
      EXTREF = 1;           // Ext Ref detected
      if( INITON && !STARTED) {
        StartCount = Phase;               // Initial delay in degrees
        STARTED = TRUE;
        }
      if( RUNNING && (maxOnCycles > 0) ) {
        OnCycles--;
        if( OnCycles <= 0 ) {
          rxChar = 0;
          SCR1 = 0;
          SCR2 = 0;
          RUNNING = FALSE;
          }
        }
      INTCONbits.INTF = 0; 
      }
  else if( PIR1bits.ADIF ) {
      ADCval = ADRESL + ADRESH*256;
      PIR1bits.ADIF = 0;
  }
  else if( INTCONbits.IOCIF ) {
      INTCONbits.IOCIF = 0;
  }
  else if(PIR1bits.RCIF == 1)
    {
        rxChar = ReadUSART(); //read the byte from rx register
        WriteUSART(rxChar);
        PIR1bits.RCIF = 0; // clear rx flag
    }
}
#endif
/*
void InterruptHandlerLow (void)
{
    INTERRLOW = 1;
}
*/

// Clock 14.7456 MHz / 4 => 3.686400
// 3.686400 MHz instruction / 60 = 61440 counts/cycle 73728 at 50 Hz
// Prescale 2:  30720 or 36864
// 30720/256 = 120 => 3 degrees, 36867/256 = 144 => 3 degrees
void    SetupTimer0()
{
#ifdef MCC
    TMR0_Initialize();
#else
  INTCONbits.GIE = 0;		//Turn off Global Interrupts
  TMR0 = 0;                    //clear timer
//  TMR0L = 0;                    //clear timer
  //T0CON <7>EN, <6>8/16 bit, <5>T0CS 0=INT, <4>T0SE, <3>PSA 0=1:2 Prescale, <2:0>PS 256-2
//  T0CON = 0b11000000;           //0x82  set up timer0 - 8 bits - prescaler 1:2
  INTCONbits.TMR0IE = 1;
//  INTCON2bits.TMR0IP = 1;       // Timer0 high priority
  INTCONbits.PEIE = 1;          //Turn on Peripheral Interrupts
  INTCONbits.GIE = 1;           //Turn on Global Interrupts
  timer0=0;
#endif  
}

// ADCON0: <7:6> N/A, <5:2> 0000=CHS3, <1> 1=GO/0=Done, <0> 1=Enable
// ADCON1: <7:6> N/A, <5> VREF- = VSS, <4> VREF+ = VDD, <3:0> 1011 = <AN0:AN3>
void    SetupADC()
{
#ifdef MCC
    ADC_Initialize();
#else
#ifdef _18F2420
    ADCON0 = 0b00000001;    // <7:6>N/A; <5:2>CHSEL 0=AN0; <1>GO/Done; <0>ON/off
    ADCON1 = 0b00001011;    // <7:6>N/A; <5>VCFG1 0=Vss; <4>VCFG0 0=Vdd; <3:0>Config 1011=AN0-3
    ADCON2 = 0b10010101;    // <7>ADFM 1=Right, <5:3>TACQ 010=4; <2:0: CS 101=fOsc/16
#else   // 18F242
    // <7:6> ADCS0:1 (10=FOsc/32), <5:3> CHS0:2 (000=AN0, 001=AN1, 010=AN2, 011=AN3)
    // <2> (1 = GO, 0 = DONE), <1> N/A, <0> (1 = ADC Powered up)
    ADCON0 = 0b00000001;
    // <7>ADFM 1=Right; <6>ADCS2 (0=2/8/32, 1 = 4/16/64);
    // <3:0> PCFG0:3 (0100 = AN0, AN1, DIO2, AN3, Ref+ = VCC, Ref- = VSS)
    ADCON1 = 0b10000100;     
                            
#endif
    PIE1bits.ADIE = 1;      // Enable ADC interrupt
#endif
}

/*
16(X+1) = Fosc/Baud Rate
16(X+1) = 14745600/9600
16(X+1) = 1536
X+1 = 1536/16
X+1 = 96
X = 95
 */
void    SetupUSART()
    {
#ifdef MCC
    EUSART_Initialize();
#else
    unsigned char UART1Config = 0, baud = 0;

    TRISCbits.TRISC6 = 0; //TX pin set as output
    TRISCbits.TRISC7 = 1; //RX pin set as input

    UART1Config = USART_TX_INT_OFF & USART_RX_INT_ON & USART_ASYNCH_MODE & USART_EIGHT_BIT & USART_BRGH_HIGH ;
    baud = 95;
    OpenUSART(UART1Config,baud);
#endif    
    }

void    DelayMsec(int msec)
    {
    if(INTCONbits.TMR0IE && INTCONbits.GIE) {
        INTCONbits.TMR0IE = 0;		//Turn off Interrupt
        timer0=(unsigned long)(7.2*msec);     // 7200/sec
        INTCONbits.TMR0IE = 1;      //Turn on interrupt
        while(timer0>0) {
            asm("NOP");
            asm("CLRWDT");
            }   
        }
    }

void    readCommand() {
    char    s[2];
    s[0] = rxChar;
    s[1] = 0;
    if( rxChar != CR ) {
        if ( strlen( (char*)Command) < MAXCMD ) {
            strcat( (char*)Command, (char*)s );
            rxChar = 0;
             }
        else {
            putsUSART((char*)"\r\n Command Error\r\n");
            strcpy( (char*)Command, (char*)"" );
            rxChar = 0; }
        }
    else {
        rxChar = 0;
        doCommand(); }
}

void    doCommand()
    {
    char   s[MAXCMD];
//    STATLED = STATERR;
//    DelayMsec(200);
    if( Command[0] == 'T') {
        Command[0] = '0';
//        maxOnCycles = atoi((char*)Command);
//        putsUSART( (char*)"\r\n");
        putsUSART( (char*)"Max On Cycles = " );
        sprintf( (char*)s, "%d", maxOnCycles );
        putsUSART( (char*)s );
        putsUSART( (char*)"\r\n");
        }
    else if (Command[0] == 'P' ) {
        Command[0] = '0';
//        Phase = atoi((char*)Command);
//        putsUSART( (char*)"\r\n" );
        putsUSART( (char*)"Phase angle = " );
        sprintf( s, "%d", Phase );
        putsUSART( (char*)s );
        putsUSART( (char*)"\r\n");
        Phase = Phase/3;       //Actual value is 3 degrees per count
        if( Phase > 0 && Phase < 180 )
            SerialSet = TRUE;
        else
            SerialSet = FALSE;
        
        }
    strcpy((char*)Command, (char*)"");
//    STATLED = STATOK;
    }

void    id() {
    putsUSART((char*)"\r\nSCR Trigger Board\r\n");
    putsUSART((char*)VERSION);
    putsUSART((char*)"\r\n");
    putsUSART((char*)DATE);
    putsUSART((char*)"\r\n"); 
    rxChar = 0;
}

/****************************** Setup PWM - Uses TMR2, T2CON **************************/
void	SetupPWM(void)	{
#ifdef MCC
    TMR2_Initialize();
    PWM3_Initialize();
    COG1_Initialize();
#else
    INTCONbits.GIE = 0;             //Turn off Global Interrupts
//    TRISAbits.TRISA5 = 1;           // disable output
    PR2 = PR2_VAL;                       // 16*4*15=960 uSec, 16*4*16=1024 uSec was 199
    CCP1CON = 0b10001100;           // <7:6>Half Bridge output P1A, P1B, <5:4>LSB, <3:0> All active high
    CCPR1L = 0;                     // Pulse width = 40*16=640/960 = 67%
    // Duty cycle = (CCPR2L + CCP2CON<4:5>) / 4*(PR4+1)
    // Duty cycle = 10*4 /4*15 = 40/60
    // Period = (PRx+1)*4*Tosc*TMRxPS = 960
    // 16 MHz clock PS=1=>20 kHz PWM, PS=4=>5 kHz PWM
    // 1/20 = (PR+1)*4/16000; PR+1 = 16000/(20*4) = 200; PR = 199
    PIE1bits.CCP1IE = 1;
    PIR1bits.CCP1IF = 0;
//    PSTR1CON = 0;
//    PSTR1CONbits.STR1B = 1;         // 1=CCP1 Output to P1B pin RA2/RA5, 0 = P1B pin is port
//    PSTR1CONbits.STR1A = 1;         // 1=CCP1 Output to P1A pin RA2/RA5, 0 = P1A pin is port

    PWM3CON = PWM3CONSET;
    TRISCbits.TRISC4 = 0;           // enable output RC4
    TRISCbits.TRISC5 = 0;           // enable output RC5
    T2CON = T2CONSET;               // <6:3> Postscale 1, <0:1> Prescale 1
    T2CONbits.TMR2ON = 1;
    INTCONbits.GIE = 1;             //Turn on Global Interrupts
#endif
}
// P=(PR2+1)*4*TOSC*PS
// PW=NUM*PS*TOSC => NUM=PW*FCLK/PS
// DC=NUM/(4*(PR2+1))
// NUM=DC*(PR2+1)*4
void    SetPWM(int DC)  {
#ifdef MCC
    PWM3_LoadDutyValue(DC);
#else            // Duty Cycle DC 0 to 100%
    unsigned long     Period;           // PWM period in uSec
//    unsigned long     PulseWidth;       // PWM pulse width in nSec
    unsigned long     Numerator;
    Period = (1000000000L*(PR2+1)*4*PSVAL)/CLKFREQ; // 20kHz:50000 nSec = 1000*200*4/16
//    PulseWidth = DC * Period / 100;     // 50% => 25000 = 50*50000/100
    Numerator = (DC*(PR2+1)*4)/100;  // PulseWidth*CLKFREQ/(4*PS);
//    Numerator /= 1000;
    PWM3DCH = Numerator & 0b00000011;
    PWM3DCL = Numerator >> 2;
#endif
}

/*----------------------------------------------------------------------------
Project Goals
 * Serial port commands, send back status for each
 * 'I' = Initiate; any other key is STOP
 * 'P' + nnn + <CR> = Set Phase angle nnn degrees
 * 'T' + nnn + <CR> = Set Time in cycles (nnn=0 to disable)
 * 
 * J1-6 connect to RC0 for MOM- (fixed 3 cycle pulse)
 * J1-7 connect to RC1 for ENA- (for Multi-Amp Mod)
-----------------------------------------------------------------------------*/